import traceback

from cpl_core.configuration.configuration_model_abc import ConfigurationModelABC
from cpl_core.console import Console


class BootLogSettings(ConfigurationModelABC):

    def __init__(self):
        ConfigurationModelABC.__init__(self)

        self._login_message_channel_id: int = 0
        self._login_message: str = ''
    
    @property
    def login_message_channel_id(self) -> int:
        return self._login_message_channel_id
    
    @property
    def login_message(self) -> str:
        return self._login_message

    def from_dict(self, settings: dict):
        try:
            self._login_message_channel_id = int(settings['LoginMessageChannelId'])
            self._login_message = settings['LoginMessage']
        except Exception as e:
            Console.error(f'[ ERROR ] [ {__name__} ]: Reading error in {__name__} settings')
            Console.error(f'[ EXCEPTION ] [ {__name__} ]: {e} -> {traceback.format_exc()}')
