from abc import ABC, abstractmethod

import discord

class PermissionServiceABC(ABC):

    @abstractmethod
    def __init__(self): pass

    @abstractmethod
    def on_ready(self): pass

    @abstractmethod
    def on_member_update(self, before: discord.Member, after: discord.Member): pass

    @abstractmethod
    def get_admin_role_ids(self, g_id: int) -> list[int]: pass

    @abstractmethod
    def get_admin_roles(self, g_id: int) -> list[discord.Role]: pass

    @abstractmethod
    def get_admins(self, g_id: int) -> list[discord.Member]: pass

    @abstractmethod
    def get_moderator_role_ids(self, g_id: int) -> list[int]: pass

    @abstractmethod
    def get_moderator_roles(self, g_id: int) -> list[discord.Role]: pass

    @abstractmethod
    def get_moderators(self, g_id: int) -> list[discord.Member]: pass
